#version 130
uniform sampler2D texture;
uniform float daylight; // 0.0 = bright, 1.0 = dark
uniform vec3 horizondelta;
uniform vec3 viewVector;
in vec4 texCoord;
in vec3 norm;
in vec4 sunDir;

in vec3 frameChange;
const float PI2 = 6.283185307179586476925286766559;

void main(void) {

	float sunphase = mod(1.25 - sunDir[3] / PI2, 1.0); // mod(frameChange[2]*0.0001, 1.0);
	float sunp = sunDir[3];
	
	vec3 nnorm = normalize(norm);
	vec3 lightPos = sunDir.xyz;
	vec3 light = normalize(lightPos);
	
	float sunlight = max(0.0, dot(light, nnorm));
//	float antisunlight = max(0.0, dot(-light, nnorm));
	float sun = pow(sunlight, 3.0);
//	float antisun = pow(0.5+0.5*antisunlight, 1.0);
	float sun2 = pow(sunlight, 300.0);
	
	// float curv = (nnorm.y + 1)*0.5;
	// nnorm.y = pow(curv, 1.0 - horizondelta[2]*0.8) * 2 - 1;
	
	float shei = 1.0-abs(nnorm.y);
	if (nnorm.y < 0)
	{
		sun2 = 0;
		shei = 1.00; // + nnorm.y*0.01;
	}
	vec4 skycol = texture2D(texture, vec2(sunphase, shei*0.99));
	
	float sx = nnorm.x * lightPos[1] - nnorm.y * lightPos[0];
	float sy = nnorm.y * lightPos[1] + nnorm.x * lightPos[0];
	
	float stars = (0.5+0.5*sin(sx * 100 + sin(sy*91))) * (0.5+0.5*sin(sy * 261)) * (0.5+0.5*sin(nnorm.z * 122));
	stars = pow(stars, 40.0) * (1 - pow(skycol[2], 0.1));
	
	
//	gl_FragColor = skycol*(1-antisun*0.2) + vec4(1.0, 0.6, 0.4, 1.0)*(sun * 0.25 + sun2) + vec4(stars);
	gl_FragColor = skycol + vec4(0.9, 0.6, 0.4, 1.0)*(sun * 0.3 + sun2) + vec4(stars);
}
