#version 130
uniform sampler2D texture;
uniform float daylight; // 0.0 = bright, 1.0 = dark
uniform vec3 focal;
in vec4 texCoord;
in float vertdist;

void main(void) {

	
	if (vertdist > focal[2]) discard;

	vec4 color = texture2D(texture, texCoord.st);
	// if (color[3] < 0.5) discard; // le discard!

	float lum = (color.r + color.g + color.b) / 3.0;
	
	// adjust edge1 for more/less clouds, 0.25 = very clouded, 0.4 = cloudy, 0.5 = less cloudy
	color[3] = smoothstep(0.0, 1.0, lum);
	color[3] = pow(color[3], 2.5);
	
	if (color[3] < 0.075) discard; //more! more!
	// again!
	color[3] = pow(color[3], 2.0);
	color[3] = smoothstep(0.0, 1.0, color[3]);
	
	const float whiteness = 3.0; // 1.0 = superdark 3.0 = superwhite
	const float darkness_subtractor = 0.5;  // darkness cutoff
	const float darkness_multiplier = 1.25; // upramp darkness
	
	float darkness = max(0.0, lum - darkness_subtractor) * darkness_multiplier;
	darkness = min(1.0,  1.0 - pow(darkness, whiteness));
	
	color.rgb = vec3(darkness * daylight);
	
	float fadedist = focal[2] * 0.80;
	if (vertdist > fadedist) {
		float depthalpha = 1.0 - (vertdist - fadedist) / (focal[2] - fadedist);
		color[3] *= depthalpha * depthalpha; //don't preserve alpha
	}
	gl_FragColor = color;

}
