#version 130
uniform sampler2D texture;
in vec4 texCoord;
in vec4 colordata;

const float SHADOW_EXP = 1.1;
const float SHADOW_MUL = 1.2;
const float SHADOW_MAX = 0.9;

void main(void) {
	
	vec4 color = texture2D(texture, texCoord.st);
	
	//light data
	float alpha = min(SHADOW_MAX, smoothstep(0.0, SHADOW_MAX, pow(colordata[3] * SHADOW_MUL, SHADOW_EXP))); //upramp shadow gamma;
	
	gl_FragColor = vec4(mix(color.rgb, colordata.rgb, alpha), 1.0);
}
